#include <windows.h>

#include "wnaspi32.h"

#ifdef __GCC__

typedef struct                                  // Offset
{                                               // HX/DEC
    BYTE        SRB_Cmd;                        // 00/000 ASPI command code = SC_GETSET_TIMEOUTS
    BYTE        SRB_Status;                     // 01/001 ASPI command status byte
    BYTE        SRB_HaId;                       // 02/002 ASPI host adapter number
    BYTE        SRB_Flags;                      // 03/003 ASPI request flags
    DWORD       SRB_Hdr_Rsvd;                   // 04/004 Reserved, MUST = 0
    BYTE        SRB_Target;                     // 08/008 Target's SCSI ID
    BYTE        SRB_Lun;                        // 09/009 Target's LUN number
    DWORD       SRB_Timeout;                    // 0A/010 Timeout in half seconds
} __attribute__ ((packed))
gSRB_GetSetTimeouts, *gPSRB_GetSetTimeouts, FAR *gLPSRB_GetSetTimeouts;

#define SRB_GetSetTimeouts gSRB_GetSetTimeouts
#define PSRB_GetSetTimeouts gPSRB_GetSetTimeouts
#define LPSRB_GetSetTimeouts gLPSRB_GetSetTimeouts

#endif

int aspi_init(void)
{
	DWORD dwSupportInfo = GetASPI32SupportInfo();
	int status = (dwSupportInfo>>8)&255;
//	int hostcount = dwSupportInfo&255;

	if (status != SS_COMP) {
		char buf[40];
		sprintf(buf,"ASPI init fail %x",dwSupportInfo);
		MessageBox(NULL,buf,NULL,MB_OK);
		return -1;
	}
	return 0;
}

static int adapter_id = 0;
static int target_id = 0;
static int target_lin = 0;
