extern int verbose;

#define	PRINTF	if (verbose) printf

typedef unsigned char u_char;

struct {
	u_char stat;
	u_char ctrl;
	int reset;

	u_char status,mode;
	u_char param[8];
	int paramptr;
	/* param */
	u_char result[8];
	int resultptr;
	int resultsize;
	struct {
		u_char minute;
		u_char second;
		u_char sector;
	} loc;

} cd;

enum {
	CdlSync,CdlNop,CdlSetLoc,CdlPlay,
	CdlForward,CdlBackword,CdlReadN,CdlStandby,
	CdlStop,CdlPause,CdlReset,CdlMute,
	CdlDemute,CdlSetfilter,CdlSetmode,CdlGetmode,
	CdlGetlocL,CdlGetlocP,Cdl18,CdlGetTN,
	CdlGetTD,CdlSeekL,CdlSeekP,CdlReadS=27
};

/*
	cdrom status

	0x80 CD-DA Play
	0x02 working?
*/

int cd0_read(void)
{
	int ret = 0; // cd.ctrl;
	if (cd.resultsize) ret|=0x20;
	return ret;
}

int cd3_read(void)
{
	return cd.stat;
}

int cd2_read(void)
{
	int ret=0;
	if (cd.resultsize) {
	  ret = cd.result[cd.resultptr++];
	  if (cd.resultptr>=cd.resultsize) {
	    cd.resultptr = cd.resultsize = 0;
	  }
	}
	return ret;
}


void cd1_write(int data)
{
	static char *cmdname[]= {
	"CdlSync","CdlNop","CdlSetLoc","CdlPlay",
	"CdlForward","CdlBackword","CdlReadN","CdlStandby",
	"CdlStop","CdlPause","CdlReset","CdlMute",
	"CdlDemute","CdlSetfilter","CdlSetmode","CdlGetmode",
	"CdlGetlocL","CdlGetlocP","Cdl18","CdlGetTN",
	"CdlGetTD","CdlSeekL","CdlSeekP","Cdl23",
	"Cdl24","Cdl25","Cdl26","CdlReadS"
	};

	if (data<28) {
		PRINTF("%s\n",cmdname[data]);
	}

	cd.status = 2;
	switch(data){
	case CdlNop:
		cd.result[0] = cd.status;
		cd.resultsize = 1;
		break;

	case CdlSetLoc:
		cd.loc.minute = cd.param[0];
		cd.loc.second = cd.param[1];
		cd.loc.sector = cd.param[2];

		cd.result[0] = cd.status;
		cd.resultsize = 1;
		break;

	case CdlPlay:
		cd.status = 0x80;

	case CdlForward:
	case CdlBackword:
	case CdlReadN:
	case CdlStandby:
	case CdlStop:
	case CdlPause:
	case CdlReset:
	case CdlMute:
	case CdlDemute:
	case CdlSetfilter:
		cd.result[0] = cd.status;
		cd.resultsize = 1;
		break;

	case CdlSetmode:
		cd.mode = cd.param[0];
		cd.result[0] = cd.status;
		cd.resultsize = 1;
		break;

	case CdlGetmode:
		cd.result[0] = cd.status;
		cd.result[1] = cd.mode;
		cd.resultsize = 2;
		break;

	case CdlGetlocL:
	case CdlGetlocP:

	case CdlGetTN:
		cd.result[0] = cd.status;
	//	cd.result[1] = 
	//	cd.result[2] = 
		cd.resultsize = 3;
		break;

	case CdlGetTD:

	case CdlSeekL:
	case CdlSeekP:
	case CdlReadS:
		cd.result[0] = cd.status;
		cd.resultsize = 1;
		break;

	default:
		PRINTF("unknown command %d\n",data);
	}
	cd.stat = 2;
	cd.resultptr = 0;
}

void cd0_write(int data)
{
/*	write 0??
	write read & 3?
*/
	cd.ctrl = data;
	if (data==0) {
		cd.paramptr = 0;
		cd.resultptr = cd.resultsize = 0;
	}
	if (data==1) cd.reset = 1;
}

void cd2_write(int data)
{
	if (cd.reset==2 && data==7) {
		cd.paramptr = 0;
		cd.resultptr = cd.resultsize = 0;
		cd.stat = 0;
		cd.ctrl = 0;
		return;
	}
	cd.reset = 0;
	if (cd.paramptr<8)
		cd.param[cd.paramptr++] = data;
}

void cd3_write(int data)
{
//	cd.stat = data;
	if (data==7 && cd.reset==1) cd.reset==2;
	else cd.reset=0;
	if (data==7) {
		cd.resultsize = cd.resultptr = 0;
		cd.stat = 0;
	}
}
